\section{Terraform}
Terraform is an open-source tool written in Go by the company Hashiscorp. The idea of terraform is to help provision infrastructure. It is one of the most used tools int the DevOps landscape. Terraform has multi-cloud support and there is a huge ecosystem build around terraform.

Infrastructure is all what we need to support the computing requirements of an application. Computing requirements are: vm, vm security, vm access to the network, firewall rules, availability, maintainability. Terraform does use its own syntax and is not dependent on yaml.

Terraform and Ansible are complementary. While Terraform does manage the infrastructure stack, Ansible is a configuration management tool.

\subsection{Architecture}
Terraform does use providers to convert the Terraform syntax to something that the SDK of the cloud provider can consume. The SDK sends API calls to the cloud provider. The client SDK is provided by the cloud provider. The provider plugin is an open-source software maintained by Hashicorp and the open source community. When using terraform, we have to install a provider that is able to communicate with a specific SDK which knows how to talk to the cloud provider. The SDK is doing the actual changes in the cloud.

The Terraform configuration acts as a single source of truth and therefore changes done in any other way than with the help of the Terraform it will simply overwrite the change the next time the configuration is applied.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{architecture}
  \caption{Terraform Architecture}
\end{figure}

\subsection{Hashicorp Configuration Language (HCL)}
A very simple to learn language with build in type system and support for loops, dynamic blocks, conditionals and string interpolation.

Most of the time we have different files in order to separate the configuration for the API keys from the actual file with the configuration for the cloud resources.

Please make yourself comfortable with the commands: plan, init and apply.

%TODO add example files for a vm and the configuration

\subsection{State of Deployment}
The "*.tfstate" file is the memory for the Terraform script. This is the way how Terraform does remember the last deployment that happened. When we reapply a Terraform configuration it checks what is deployed in the cloud and compares what in the Terraform script has changed in comparison to the deployed resources. Terraform will only change the configuration of the resources it needs to. With the help of the "plan" command we can check if any resource have been changed. 

\subsection{Writing in HCL}
The CLI will combine all the "*.tf" files from the source into one deployment. 

\subsubsection{Outputs}
Are used to output the value of a deployment. For example we can display the used ip address after the deployment. The list of attributes which we can print can be found in the documentation.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{terraformoutput}
  \caption{Terraform Output}
\end{figure}

\subsubsection{Variables}
If a variable is defined without a default value, the operator will be prompted to enter the value. A variable can be exported in the shell as an environment variable. Important is the suffix "TF\_VAR\_". Then the port variable is 8080. The same is possible with the access\_key and secret\_key in the "provider.tf" file. Either they are configured in the "provider.tf" file or they are environment variables with the suffix TF\_VAR.

\begin{lstlisting}
variable "users" {
  type    = list
  default = ["root", "user1", "user2"]
}

variable "set_password" {
  default = false
}

resource "cloud_server" "server1" {
	hostname = var.users[0]
}
\end{lstlisting}


Variables set in the file can be overridden at deployment. This allows you to reuse the variables file while still customising the configuration at deployment. For example, although set\_password is false in the variables file, you could enable it on the command line.

\begin{lstlisting}
terraform apply -var set_password="true"
\end{lstlisting}


\subsection{CLI}
When you run "apply" the first time in a directory, terraform will notice that there is no state file and update the cloud and create the state file.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{deploymentstate}
  \caption{Terraform state in a deployment}
\end{figure}

Any other "apply" the cli will read the script (NEW) and reach out to the cloud to see what is already provisioned (EXISTING) and compare it with the state file (PREVIOUS) to get the difference. Terraform makes a 3-way diffs between NEW, EXISTING and PREVIOUS to get a full picture of the current situation and then decides what to do.


\subsubsection{State File}
Terraform is associating the name of the terraform resource with the "arn id" of the instance. So it knows that the last time it run, it created that exact EC2 instance. The terraform resource is the existing desired state in the script. The arn is used to check the cloud and see if anything has changed. So the .tfstate file makes the link between the existing script and what is deployed.

\paragraph{Sharing the State File} \hfill \\
To work in teams, the state file should be shared with the other team members. Terraform allows you to store your state file in a third party, in the example here, in Amazon S3.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.35\textwidth]{terraformstate}
  \caption{Terraform Shared State with AWS}
\end{figure}


\subsubsection{Organization}
A good plan is to create a folder for each environment. Every folder gets his own state file. It is important not to mix state files of different environment. The state file can get corrupted. (it happens every now and then). If we are working with a folder structure like this, only the state file of one environment is corrupted at a time.




